import InputManager;

class SnakeGame {
      	private var _container : flash.MovieClip;
	private var _input : InputManager;
	private var _snake : Snake;

      	public function new()
	{
             	_container = flash.Lib._root.createEmptyMovieClip("Snake Game", 1);
             	_container.onEnterFrame = main_loop;
	     	_container.focus();
	     	flash.Mouse.hide();
		_snake = new Snake(50, 50);

		var binder = function(obj, arg){ return function(){ obj(arg); } };

		_input = new InputManager();
		_input.bind(InputManager.SPCL_KEY_LeftArrow, binder(_snake.move_left, 10));
		_input.bind(InputManager.SPCL_KEY_RightArrow, binder(_snake.move_right, 10));
		_input.bind(InputManager.SPCL_KEY_UpArrow, binder(_snake.move_up, 10));
		_input.bind(InputManager.SPCL_KEY_DownArrow, binder(_snake.move_down, 10));
	}

	static function main()
	{
		new SnakeGame();
	}
      
	private function main_loop()
	{
		_input.handleInput();
		_container.clear();
		_snake.draw(_container);
	}
}



class Snake
{
	private var _x : Int;
	private var _y : Int;
	private var _s : Int;
	private var _color : Int;

	public function new(x : Int, y : Int)
	{
		_x = x;
		_y = y;
		_s = 10;
		_color = 0xFF0000;
	}
	
	public function draw(clip : flash.MovieClip)
	{
		clip.beginFill(_color);
        	clip.moveTo(_x, _y);
        	clip.lineTo(_x + _s, _y);
        	clip.lineTo(_x + _s, _y + _s);
        	clip.lineTo(_x, _y + _s);
        	clip.endFill();
	}

	public function move_up(step : Int)
	{
		_y -= step;
	}

	public function move_down(step : Int)
	{
		_y += step;
	}

	public function move_left(step : Int)
	{
		_x -= step;
	}

	public function move_right(step : Int)
	{
		_x += step;
	}
}